
/**
 * 
 * Driver class.
 * 
 * @author Nicolae Ciprian Mocanu
 *
 */
import static javax.swing.JFileChooser.APPROVE_OPTION;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedInputStream;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintStream;


import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.ScrollPaneConstants;
import javax.swing.filechooser.FileNameExtensionFilter;



public class Driver {
	JMenu aboutMenu;
	JMenuItem loadPatternItem;
	public  JMenuItem  fileDirItem;
	public  JMenuItem exitItem;
	
	public  JFrame frame;
	public  JPanel panel;
	 JTextArea textArea;
	String filename;
	
	
	 byte [] patternABC =  {0x41, 0x42, 0x43};
  	 byte [] patternXYZ =  {0x58, 0x59, 0x5A};
	BytePattern byt1 = new BytePattern(patternABC);
	BytePattern byt2 = new BytePattern(patternXYZ);
	
	
	Hexadecimal hex = new Hexadecimal();
	JFileChooser fileChooser;
	File file;
	JScrollPane scroll;
	String text;
	InputStream inputStream,inputStream2;
	String line = "";
	int totalLine=0;
	
	
	/**
	 * the graphical user interface
	 */
	
	public  Driver()
	{
		 frame = new JFrame("Assignment Software Systems Development");
	        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	        
	         panel = new JPanel();    
	        panel.setPreferredSize(new Dimension(600, 300));
	        
	        textArea =new JTextArea(300,50);
	        textArea.setEditable(false);
	        PrintStream printStream = new PrintStream(new CustomOutputStream(textArea));
	        System.setOut(printStream);
	        System.setErr(printStream);
	        panel.add(textArea);
	       
	      scroll = new JScrollPane(textArea);
	      //scroll.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
	      scroll.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
	     
	      
	        panel.add(scroll);
	        
	        JMenuBar menuBar = new JMenuBar();
	        menuBar.setBackground(Color.GRAY);
	       
	        JMenu fileMenu = new JMenu("File");
	        fileMenu.setForeground(Color.BLUE);
	        menuBar.add(fileMenu);
	        
	         fileDirItem= new JMenuItem("Select File/Directory");
	        fileDirItem.addActionListener( new myActionListener());
	        fileMenu.add(fileDirItem);
	        
	         exitItem = new JMenuItem("Exit");
	         exitItem.addActionListener( new myActionListener());
	        fileMenu.add(exitItem);
	        
	        loadPatternItem = new JMenuItem("Load Pattern File");
	        loadPatternItem.addActionListener( new myActionListener());
	        fileMenu.add(loadPatternItem);
	        
	       
	        
	        aboutMenu = new JMenu("About");
	        aboutMenu.setForeground(Color.BLUE);
	        aboutMenu.addMouseListener(new myMouseListener());
	        menuBar.add(aboutMenu);
	        
	        frame.setJMenuBar(menuBar);
	        frame.getContentPane().add(panel);
	        
	        
	        frame.pack();
	        frame.setVisible(true);
	        
	        
	}

	
	public static void main(String[] args) {
		
		Driver object = new Driver();
		
		
	}
	
	public  class myMouseListener implements MouseListener
	{

		@Override
		public void mouseClicked(MouseEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void mouseEntered(MouseEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void mouseExited(MouseEvent arg0) {
			// TODO Auto-generated method stub
			
		}
/*
 * the presentation of this application
 * if user select about menu this message dialogue will be displayed 
 */
		@Override
		public void mousePressed(MouseEvent event) {
			if(event.getSource()==aboutMenu)
			{
				JOptionPane.showMessageDialog(
					    frame, 
					    "Hello! My name is Nicolae Ciprian Mocanu , "+
					    "and today we gonna scan some files looking for bytes pattern. \n"+
					   "You can do this if you select the file menu of the application, there are 3 options availabe:\n"+
					    "-if you select the 1st menu item (Select file/directory), you can scan any file or directory using 2 patterns already defined\n"+
					   "-if you select the 2nd menuitem (Exit), the application will close \n"+
					    "-if you select the 3rd menuitem (Load Pattern File), you will be ask to select a file to set your \n own patterns and after that you will be asked to select another file to scan using the patterns./n"+
					   "I hope you will enjoy using the application ! :)",
					  
					    
					    filename, JOptionPane.INFORMATION_MESSAGE); 
			}
			
		}

		@Override
		public void mouseReleased(MouseEvent arg0) {
			
		}
		
	}

	
public  class myActionListener implements ActionListener  
{


		@Override
		public void actionPerformed(ActionEvent e){
			/**
			 * the 1st option of file menu
			 */
			
			if(e.getSource()==fileDirItem)
			{
                
          JOptionPane.showMessageDialog(frame, "Choose a file/directory to scan","confirmation" , JOptionPane.OK_CANCEL_OPTION );

	try {

		fileChooser= new JFileChooser();
		
		fileChooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
		//fileChooser.setCurrentDirectory(new File("c:\\temp"));
		int returnValue=fileChooser.showOpenDialog(panel);
		if(returnValue == JFileChooser.APPROVE_OPTION)
		{
			/**
			 * if user select directory
			 *@param files  stores the drectory's file into a file array
			 */
			if(fileChooser.getSelectedFile().isDirectory())
			{
			file=fileChooser.getSelectedFile();
			File[] files = file.listFiles();
			String directoryName=fileChooser.getSelectedFile().getName();
			System.out.println("\n\nDirectory :" + directoryName );
			/**
			 * loading the next file from files 
			 */
			
			for(File nextFile : files)
			{
				String nextFileName = nextFile.getName();
				System.out.println( "\n\nFilename :" +  nextFileName );
				inputStream = new BufferedInputStream(new FileInputStream(nextFile));
				int next;
				
				 /**
				  * i am scanning the file using the 1st BytePattern object 
				  */
				
				while ((next = inputStream.read()) != -1) {
					
					
					
			        byte nextByte = (byte)next;
			       /**
			        * if a pattern is found 
			        * all the bytes and the offset will be displayed
			        */
			      
			    	   byt1.check(nextByte);
			    	   
			    	  
			       }
				/**
				 * reset checkPos,offset,flag
				 */
				byt1.reset();
				
	inputStream = new BufferedInputStream(new FileInputStream(nextFile));
				
				int next1;
			/**
			 * i am scanning the 2nd BytePattern object
			 */
				 
				
				while ((next1 = inputStream.read()) != -1) {
					
					
					
			        byte nextByte = (byte)next1;
			       
			      
			    	   byt2.check(nextByte);
			    	   
			    	  
			       }
				byt2.reset();
				
			}
			}
			else
			{
				/**
				 * if user select file for scanning
				 */
				
				file=fileChooser.getSelectedFile();
				String filename=fileChooser.getSelectedFile().getName();
			System.out.println( "\nFilename :" +  filename );
		 
			
			
			inputStream = new BufferedInputStream(new FileInputStream(file));
			
			int next;
		
			 
			
			while ((next = inputStream.read()) != -1) {
				
				
				
		        byte nextByte = (byte)next;
		       
		      
		    	   byt1.check(nextByte);
		    	   
		    	  
		       }
			byt1.reset();
			
inputStream = new BufferedInputStream(new FileInputStream(file));
			
			int next1;
		
			 
			
			while ((next1 = inputStream.read()) != -1) {
				
				
				
		        byte nextByte = (byte)next1;
		       
		      
		    	   byt2.check(nextByte);
		    	   
		    	  
		       }
			byt2.reset();
			
			
			
			
		   
		    
			
		}
				
		}
	} catch (IOException e1) {
		
		e1.printStackTrace();
	}
	
    }
	
			
				
			
			else if (e.getSource()==exitItem)
			{
				System.exit(0);
			}
			
			
			else if (e.getSource()==loadPatternItem)
			{
				try {
					hex.savePatterns();
				} catch (IOException e1) {
				
					e1.printStackTrace();
				}
				

				fileChooser= new JFileChooser();
				
				fileChooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
				//fileChooser.setCurrentDirectory(new File("c:\\temp"));
				int returnValue=fileChooser.showOpenDialog(panel);
				if(returnValue == JFileChooser.APPROVE_OPTION)
				{
					//if(fileChooser.getSelectedFile().isDirectory())
					file=fileChooser.getSelectedFile();
					String filename=fileChooser.getSelectedFile().getName();
					System.out.println( "\n\nFilename :" +  filename );
				 
					//bytePatterns list has 4 objects inside
					for( int a=0 ; a < hex.bytePatterns.size(); a++)
					{
					try {
						inputStream = new BufferedInputStream(new FileInputStream(file));
					} catch (FileNotFoundException e1) {
						
						e1.printStackTrace();
					}
					
					
					int next;
					
						try {
							while ((next = inputStream.read()) != -1)
							{
								byte nextByte = (byte)next;
								hex.bytePatterns.get(a).check(nextByte);
							}
						} catch (IOException e1) {
							
							e1.printStackTrace();
						}
						
					
					hex.bytePatterns.get(a).reset();
					
					
					
					}
				
				
					}
					
			
		}

		
		}
}
}
		
		


